﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GridGroupBySlowExample {
    public partial class Form1 : Form
    {
        Stopwatch stopWatch;
        private readonly BindingList<Foo> Items = new BindingList<Foo>();
        private int Counter;

        public Form1()
        {
            InitializeComponent();
        }

        private void DoPerformanceTest()
        {
            FillItems();
            ultraLabel1.Text = (++Counter).ToString();
        }

        private void FillItems()
        {
            Infragistics.Win.UltraWinGrid.UltraGridLayout layout = this.ultraGrid1.DisplayLayout.Clone();

            Items.Clear();
            for (var i = 0; i < 10000; i++)
                Items.Add(new Foo(i.ToString(), GetGroup(i)));

            this.ultraGrid1.DisplayLayout.CopyFrom(layout);
        }

        private string GetGroup(int i)
        {
            var c1 = (char)(65 + ((i / 26) % 15));
            var c2 = (char)(65 + (i % 26));

            return c1.ToString() + c2.ToString();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = Items;
            ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("Group", false, true);
            FillItems();
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            this.ultraGrid1.Paint += ultraGrid1_Paint;
            this.ultraLabel1.Paint += ultraLabel1_Paint;

            this.stopWatch = Stopwatch.StartNew();
            DoPerformanceTest();
            Debug.WriteLine("Finished DoPerformanceTest: " + this.stopWatch.ElapsedMilliseconds.ToString());
        }        

        void ultraGrid1_Paint(object sender, PaintEventArgs e)
        {
            this.ultraGrid1.Paint -= ultraGrid1_Paint;
            Debug.WriteLine("Grid Painted: " + this.stopWatch.ElapsedMilliseconds.ToString());
        }

        void ultraLabel1_Paint(object sender, PaintEventArgs e)
        {
            this.ultraLabel1.Paint -= ultraLabel1_Paint;
            Debug.WriteLine("Label Painted: " + this.stopWatch.ElapsedMilliseconds.ToString());
            this.stopWatch.Stop();
        }

    }  

  internal class Foo {
    public Foo(string name, string group) {
      Name = name;
      Group = group;
    }

    public string Name { get; set; }
    public string Group { get; set; }
  }
}
